\documentclass[a4paper,10pt]{report}
\usepackage[utf8]{inputenc}
\usepackage{amsmath}
\usepackage{amssymb,amsfonts,textcomp}
\usepackage{array}
\usepackage{hhline}
\usepackage{hyperref}
\hypersetup{colorlinks=true, linkcolor=blue, citecolor=blue, filecolor=blue, urlcolor=blue, pdftitle=, pdfauthor=Gilles Vuidel, pdfsubject=, pdfkeywords=}
\usepackage{graphicx}
\usepackage[top=2.5cm,bottom=2.5cm,left=2.5cm,right=2.5cm,nohead]{geometry}
\usepackage{float}
\usepackage{parskip}
\usepackage{caption}
\usepackage{subcaption}
\usepackage{fancyvrb}
\makeatletter
\newcommand\arraybslash{\let\\\@arraycr}
\makeatother
% centering figures
\makeatletter
\g@addto@macro\@floatboxreset\centering
\makeatother
\setlength\tabcolsep{1mm}
\renewcommand\arraystretch{1.3}

% saut après itemize
\let\EndItemize\enditemize
\def\enditemize{\EndItemize\medskip}


\begin{document}
\begin{titlepage}
	
	\centering
	\includegraphics[scale=0.5]{img/logo.png}\\
	
	\bigskip
	\bigskip
	\bigskip	
	{\Huge
		\bfseries
		Fractalyse 3.0\\
		\bigskip
		User manual\\
	}
	\bigskip
	\bigskip
	\bigskip
	\bigskip
	\bigskip
	
	{\Large		
		Gilles Vuidel and Cécile Tannier\\
		\bigskip
		2022-01-17\\
	}
	
\end{titlepage}

\parindent 0pt

\tableofcontents

\part{Generalities}

\chapter{Introduction}
\section{About Fractalyse 3.0}
Fractalyse is a software application for the fractal analysis of 2D patterns (sets of points). 
This version 3 of Fractalyse has been written in Java language, from which results the improvement of data management with GIS (Geographical Information Systems), graphical user interface and performance with parallelism. Fractalyse runs on any computer supporting Java Virtual Machine.
\section{Authors}
Fractalyse has been developed by Gilles Vuidel at ThéMA laboratory (CNRS – University of Franche-Comté, Besançon, France). 
\section{Terms of use}
Fractalyse is distributed free-of-charge. Users must cite it (with the number of the version used) in their publications.
The source code is available and licensed in GPLv3.
\section{System requirements}
Fractalyse 3.0 runs on any computer supporting Java 1.8 or later (PC under Linux, Windows, Mac, etc.). Please note that when dealing with very large data sets, the amount of RAM memory of the computer can limit the maximum image size that can be processed in a single run with Fractalyse. In addition, for some methods, processing power (CPU) will determine the speed of computing. For details, see section \ref{pref_menu} and \ref{perf_cli} below.
\section{How to install Fractalyse on your PC?}
Download and install Java 1.8+ from \href{https://adoptium.net/?variant=openjdk11}{adoptium.net}.\\
Download fractalyse-3.0.jar from \href{https://sourcesup.renater.fr/www/fractalyse/}{sourcesup.renater.fr/www/fractalyse/} then launch it.

\chapter{Input data}
Fractalyse can read vector and raster input data.
\subsubsection{Vector data}
Fractalyse supports the vector formats \textit{geopackage} (.gpkg),  \textit{geojson} (.geojson) and \textit{shapefile} (.shp), and three types of geometries: points, lines, and polygons.
\subsubsection{Raster data}
Fractalyse supports the raster formats TIFF and Ascii Grid.

Ascii grid is a text format. An image is described as a matrix preceded by a header of 5 lines:
\begin{Verbatim}
	ncols       5
	nrows       5
	xllcorner   0
	yllcorner   0
	cellsize    1
	1 0 0 0 1
	0 1 0 1 0
	0 0 1 0 0
	0 1 0 1 0
	1 0 0 0 1
\end{Verbatim}

TIFF is a binary format commonly used for raster images. It can contain an extension named GeoTIFF, which adds spatial references to the image. Fractalyse supports TIFF images with or without GeoTIFF extension. It does not support RGB color images. Consequently, you must convert your color image into a gray scale image before analysing it with Fractalyse.

\chapter{Fractal analysis methods}
Here we describe the basic principles of the fractal analysis methods integrated in Fractalyse. 
\section{Monofractal analysis}
\label{monofractal_method}
Fractalyse proposes four methods to estimate the (mono-)fractal dimension of a 2D object:
\begin{itemize}
	\item box counting analysis
	\item dilation analysis
	\item correlation analysis
	\item radial analysis
\end{itemize}

In any case, estimating a fractal dimension involves:
\begin{itemize}
	\item a counting process,
	\item an estimation process.
\end{itemize}

\subsubsection{Counting process}

The counting process operates step by step following an iterative logic. At each iteration step, the number of elements (polygons, pixels...) contained in a counting window is counted. From one step to the next, the size of the counting window is enlarged. Thus two elements vary according to the counting step (iteration step) (i):
\begin{itemize}
	\item the number of counted elements ($N_i$),
	\item the size of the counting window ($r_i$).
\end{itemize}
	
The series of points ($r_i$, $N_i$) is plotted on a two-dimension graph. The Y-axis corresponds to the number of counted elements ($N_i$) and the X-axis corresponds to the size the counting window ($r_i$), which increases from step to step.

\subsubsection{Estimation process}
The series of points ($r_i$, $N_i$) forms a curve (named the empirical curve). This empirical curve is fitted with another one, the estimated curve. If the empirical curve follows a (mono-)fractal law, the estimated curve has the form of a power law (parabolic or hyperbolic):
$$N = r^D$$ or $$N = r^{-D}$$
where $D$ is the fractal dimension.
Usually, the empirical curve is represented on a log-log plot. Thus the estimation is a linear regression and $D$ is the slope of the resulting estimated straight line.
$$\log N = \log r^D = D \log r$$

\subsection{Box counting analysis}
\label{box_method}
Box counting analysis is the simplest method that can be used to estimate a fractal dimension. The pattern under analysis is covered by a quadratic grid. The size of the grid cells $r_i$ increases from one iteration step to the next. Considering each grid cell size $r_i$, the number of cells $N_i$ containing at least one point (black pixel in case of raster data; point, line or polygon in case of vector data) is counted. 

\begin{figure}[H] 
%	\begin{subfigure}{0.16\textwidth}
%		\includegraphics[scale=0.15]{img/box_tapis_1.png}
%		\caption*{$r:1$ $N=3125$}
%	\end{subfigure}
%	\begin{subfigure}{0.16\textwidth}
%		\includegraphics[scale=0.15]{img/box_tapis_3.png}
%		\caption*{$r:3$ $N=625$}
%	\end{subfigure}
	\begin{subfigure}{0.24\textwidth}
		\includegraphics[scale=0.22]{img/box_tapis_9.png}
		\caption*{$r:9$ $N=125$}
	\end{subfigure}
	\begin{subfigure}{0.24\textwidth}
		\includegraphics[scale=0.22]{img/box_tapis_27.png}
		\caption*{$r:27$ $N=25$}
	\end{subfigure}
	\begin{subfigure}{0.24\textwidth}
		\includegraphics[scale=0.22]{img/box_tapis_81.png}
		\caption*{$r:81$ $N=5$}
	\end{subfigure}
	\begin{subfigure}{0.24\textwidth}
		\includegraphics[scale=0.22]{img/box_tapis_243.png}
		\caption*{$r:243$ $N=1$}
	\end{subfigure}
\end{figure}
\begin{figure}[H]
	\begin{subfigure}{0.5\textwidth}
		\includegraphics[scale=0.3]{img/plot_box.png}
	\end{subfigure}
	\begin{subfigure}{0.2\textwidth}
		$$D \sim 1.465$$
	\end{subfigure}
\end{figure}

\subsection{Dilation analysis}
\label{dil_method}
Each point of the pattern (black pixel in case of raster data; polygon in case of vector data) is surrounded by a square (or a circle) of size $r_i$, the surface of which is considered to be completely occupied. These squares or circles are gradually enlarged, and the total area $A(r_i)$ covered at each stage $i$ of the dilation process is measured.
As the squares are enlarged, any details smaller than $r_i$ are overlooked. More and more squares overlap and the total occupied area $A(r_i)$ for a particular value $r_i$ is lower than it would be if the same number of points that make up the original shape would have been surrounded individually. By dividing this total area by the area of a square ($r_i^2$) or a circle ($\pi\frac{r_i}{2}^2$), we obtain an approximation of the number of elements $N_i$ required to cover the whole pattern.

$$ N_i \approx \frac{A(r_i)}{r_i^2} \text{ or } \frac{A(r_i)}{\pi\frac{r_i}{2}^2}$$

\begin{figure}[H]
	\begin{subfigure}{0.18\textwidth}
		\includegraphics[scale=0.15]{img/dil_tapis_1.png}
		\caption*{$r:1$}
	\end{subfigure}
	\begin{subfigure}{0.18\textwidth}
		\includegraphics[scale=0.15]{img/dil_tapis_3.png}
		\caption*{$r:3$}
	\end{subfigure}
	\begin{subfigure}{0.18\textwidth}
		\includegraphics[scale=0.15]{img/dil_tapis_9.png}
		\caption*{$r:9$}
	\end{subfigure}
	\begin{subfigure}{0.18\textwidth}
		\includegraphics[scale=0.15]{img/dil_tapis_27.png}
		\caption*{$r:27$}
	\end{subfigure}
	\begin{subfigure}{0.18\textwidth}
		\includegraphics[scale=0.15]{img/dil_tapis_81.png}
		\caption*{$r:81$}
	\end{subfigure}	
\end{figure}
\begin{figure}[H]
	\begin{subfigure}{0.5\textwidth}
		\includegraphics[scale=0.3]{img/plot_dil.png}
	\end{subfigure}
	\begin{subfigure}{0.2\textwidth}
		$$D \sim 1.454$$
	\end{subfigure}
\end{figure}

\subsection{Correlation analysis}
\label{cor_method}
Each point of the pattern is surrounded by a small square (or circle) window. The number of points (black pixels in case of raster data) within each window is counted. Then the mean number of points per window size is calculated ($N_i$). The same operation is applied for windows of increasing sizes $r_i$. In principle, it is possible to choose any shape for the counting window, such as circle, hexagon, etc. Yet in Fractalyse, the counting window is a square for raster data, which helps us to avoid rounding errors, and a circle for vector data. Note: because the correlation analysis considers the simultaneous presence of two points at a certain distance, i.e. the mean distance between a pair of points, the correlation dimension is a second order fractal dimension.

\begin{figure}[H]
	\begin{subfigure}{0.5\textwidth}
		\includegraphics[scale=0.3]{img/plot_cor.png}
	\end{subfigure}
	\begin{subfigure}{0.2\textwidth}
		$$D \sim 1.44$$
	\end{subfigure}
\end{figure}

\subsection{Radial analysis}
\label{radial_method}
The radial analysis is identical to the correlation analysis but only one counting point is considered.
The counting point is located anywhere in the pattern (most often at the centre of the pattern). A counting window is drawn around the counting point. Its size grows at each iteration step $r_i$. The number of points $N_i$ within the window is counted.\\
As for the correlation analysis, the shape of the counting window is a square for raster data and a circle for vector data.

\begin{figure}[H] 
%	\begin{subfigure}{0.18\textwidth}
%		\includegraphics[scale=0.15]{img/rad_tapis_3.png}
%		\caption*{$r:3\sqrt{2}$ $N=5$}
%	\end{subfigure}
	\begin{subfigure}{0.24\textwidth}
		\includegraphics[scale=0.24]{img/rad_tapis_9.png}
		\caption*{$r:9\sqrt{2}$ $N=25$}
	\end{subfigure}
	\begin{subfigure}{0.24\textwidth}
		\includegraphics[scale=0.24]{img/rad_tapis_27.png}
		\caption*{$r:27\sqrt{2}$ $N=125$}
	\end{subfigure}
	\begin{subfigure}{0.24\textwidth}
		\includegraphics[scale=0.24]{img/rad_tapis_81.png}
		\caption*{$r:81\sqrt{2}$ $N=625$}
	\end{subfigure}
	\begin{subfigure}{0.24\textwidth}
		\includegraphics[scale=0.24]{img/rad_tapis_243.png}
		\caption*{$r:243\sqrt{2}$ $N=3125$}
	\end{subfigure}
\end{figure}
\begin{figure}[H]
	\begin{subfigure}{0.5\textwidth}
		\includegraphics[scale=0.3]{img/plot_rad.png}
	\end{subfigure}
	\begin{subfigure}{0.2\textwidth}
		$$D \sim 1.465$$
	\end{subfigure}
\end{figure}


\section{Multifractal analysis}
\label{multifractal_method}
Whereas monofractal analyses are performed on binary images representing the presence or absence of a phenomenon (e.g. built-up surfaces), multifractal analyses also take into account the relative amount of the phenomenon in each place. The intensity of the phenomenon under consideration varies with the spatial aggregation level. Multifractal analysis can be thought of as an extension of monofractal analysis by the addition of information about the relative intensity in each place of the phenomenon under consideration. It integrates not just a series of nested spatial resolutions (i.e. analyzing the phenomenon using spatial units of nested sizes), as monofractal analysis does \cite{frankhauser1998fractal, stanley1999stat}, but also a series of points of view about the quantity of information contained in each spatial unit \cite{semecurbe2016}.

Multifractal analysis consists in analysing the spatial distribution of the measure $\mu_{i,r}$ for a series of scales $r$ and then to observe the result of the function when $r$ changes. Obviously, a single function is not enough to fully characterize the spatial distribution of the measure $\mu_{i,r}$. Alternatively, a group of functions, namely the structure functions $M_{r,q}$, are suitable for this:

$$M_{r,q} = \sum_i{\mu_{i,r}}^q$$

\begin{figure}[H]
	\includegraphics[scale=0.4]{img/mq.png}
	\caption{A series of structure functions $M_{r,q}$}
\end{figure}

Multifractal analysis requires us to set the assumption that the structure functions $M_{r,q}$ follow a scaling law when the values of $r$ are small: 

$$M_{r,q}\approx r^{\tau_q}$$

$\tau_q$ is a scaling exponent. It can be calculated using the following formula:
$$\tau_q=\lim_{r\to 0} \frac{\log{M_{r,q}}}{-\log r}$$

Of course, it is impossible to reduce $r$ toward 0 indefinitely. Consequently, the estimation of $\tau_q$ is given by the slope of the curve of $\log M_{r,q}$ as a function of $\log r$.

\begin{figure}[H]
	\includegraphics[scale=0.4]{img/tq.png}
	\caption{$\tau_q$}
\end{figure}

On the basis of $\tau_q$, it is possible to define the generalized dimensions $D_q$: 

$$D_q=\frac{1}{1-q}\tau_q \text{ for } q\ne1$$

\begin{figure}[H]
	\includegraphics[scale=0.4]{img/dq.png}
	\caption{Dimension spectrum $D_q$}
\end{figure}

\subsubsection{Dimension spectrum}
$D_q$ with respect to $q$ is called the dimension spectrum. The coefficient $q$ acts as a filter when calculating the generalized dimensions. For $q \to +\infty$, only the cells in which high measures are concentrated are taken into account. Conversely, for $q \to -\infty$ generalized dimensions describe the spatial distribution of the elements in which low measures are concentrated. For $q=1$, all cells have the same importance whatever their measure. For $q=0$, the generalized dimension does not take into account the spatial variation of the measure; only the fact that the cells are populated or not is taken into account. Because of this sort of filtering operated by $q$, generalized dimensions $D_q$ allow a characterization of the spatial distribution of population that is both multiscale (via the scale $r$) and multi-viewpoint (via the exponent $q$) \cite{semecurbe2016}. 

\subsubsection{Singularity spectrum $f(\alpha_q)$ (also called multifractal spectrum)}
The multifractal formalism enables the determination of the singularity spectrum through a Legendre transform of the scaling exponent $\tau_q$ \cite{jaffard2007}. $f(\alpha_0)$ gives the maximum value of the singularity spectrum. It indicates the strength of the irregularities of the measure. Complementarily, the range of the spectrum informs us about the multifractality of the spatial distribution of the measure (more or less strong, even non-existent in the case of a monofractal distribution) \cite{wendt2007}. 

\begin{figure}[H]
	\includegraphics[scale=0.4]{img/falpha.png}
	\caption{Singularity spectrum $f(\alpha_q)$}
\end{figure}

Case studies in spatial analysis are highly dependent on the size of the spatial units used for the analysis. This has been expressed by \cite{openshaw83} as the Modifiable Areal Unit Problem (MAUP): whatever the phenomenon under consideration, it is impossible to identify a single spatial partition that would be most appropriate for analyzing it. Interestingly, both spectrums $D_q$ and $f(\alpha_q)$ enlighten the MAUP \cite{semecurbe2016}.
\begin{itemize}
\item The absence of MAUP means that the spatial distribution of population is almost uniform. In this case, the dimension spectrum is a horizontal line with the y-intercept equal to $2$ and the singularity spectrum is the point of coordinates $(2,2)$.
\item When the measure is monofractal then the singularity spectrum $f(\alpha_q)$ is only a point of coordinates $\alpha_q = f(\alpha_q) = D_0$. In this case, the MAUP only results from the spatial distribution of the populated places. Basically, the study area contains identical buildings all having the same number of inhabitants and being spatially distributed in a monofractal manner. In this case, local differences in population density come only from the spatial distribution of the buildings. 
\item A singularity spectrum having a range of $\alpha_q$ values indicates a multifractal behavior. In this case, the spatial footprint of the buildings varies (e.g. small single-family houses, multi-family houses, high and large collective buildings) as well as their number of inhabitants: the MAUP results from both.
\end{itemize}

\subsection{Box counting multifractal analysis}
\label{multi_box_method}
The counting method follows the same principle as the monofractal box counting method (\ref{box_method}) except that $\mu_{i,r}$ measures here the proportion of elements in the grid cell $i$ of size $r$ and not just the fact that the grid cell is occupied or not.\\

For $q=1$ $D_q$ is:
$$D_1=\lim_{r\to 0} \frac{\log{\sum_i \mu_{i,r}\log{\mu_{i,r}}}}{\log{r}}$$

When $q=0$, the function $M_{r,q}$ corresponds to the mono-fractal box counting function, i.e. the number of occupied cells is simply counted whatever the proportion of elements within each grid cell.

\subsection{Sandbox}
\label{multi_sandbox_method}
The counting method follows the same principle as the monofractal correlation method (\ref{cor_method}).\\
Since the sandbox dimension is a second order fractal dimension, $q$ exponent in $M_{r,q}$ is shifted:
$$M_{r,q} = \frac{1}{n}\sum_{i=1}^n{\mu_{i,r}}^{q-1}=\langle{\mu_{i,r}}^{q-1}\rangle$$

When $q=2$ the function $M_{r,q}$ is equivalent to the mono-fractal correlation dimension.\\

For $q=1$ $D_q$ is:
$$D_1=\lim_{r\to 0}\frac{\langle\log{\mu_{i,r}}\rangle}{\log{r}}$$


\section{Network analysis}
Correlation (\ref{cor_method}), radial (\ref{radial_method}) and sandbox (\ref{multi_sandbox_method}) analyses have been adapted to deal with network data. In this case, the size $r_i$ measured is not a euclidean distance but a network distance (topological distance, metric length or any cumulative cost). The counted elements $N_i$ can be the edges or the nodes of the graph as chosen by the user.

\bibliographystyle{biblio}
\bibliography{biblio}


\part{Graphical user interface}

\chapter{Data}
\section{Loading data: \texttt{File} menu}
\subsection{\texttt{Load vector data} menu}
Fractalyse can read three types of vector data from Geographic information systems (GIS): Geopackage (.gpkg), GeoJSON (.geojson) and Shapefile (.shp).\\
Three types of geometries are supported: points, lines, and polygons.

When a shapefile is loaded with the menu \texttt{Load vector data}, a new layer is created and displayed in the GUI (graphical user interface).

\begin{figure}[H]
	\includegraphics[scale=0.5]{img/load_vector.png}
	\caption{Vector data loaded in Fractalyse}
\end{figure}

\subsubsection{Network vector data}
If the vector layer contains only simple linear geometries, a graph representation of the network is automatically created. This allows the user to perform network analysis in addition to vector analysis.

\begin{figure}[H]
	\includegraphics[scale=0.5]{img/load_net.png}
	\caption{Vector network data loaded in Fractalyse}
\end{figure}


\subsection{\texttt{Load raster data} menu}
Fractalyse can read two types of raster data: TIFF and Ascii Grid.

When the input data file is loaded with the menu \texttt{Load raster data} menu, a new layer is created and the image is displayed. If the image contains only 0 and 1 values, Fractalyse classifies the layer as a binary layer and sets white color for 0 and black color for 1. Otherwise, it sets a gray scale color ramp for the image. Color images (RGB) are not supported.

\begin{figure}[H]
	\includegraphics[scale=0.5]{img/load_raster.png}
	\caption{Raster binary data loaded in Fractalyse}
\end{figure}

\begin{figure}[H]
	\includegraphics[scale=0.5]{img/load_raster_grey.png}
	\caption{Raster gray scale layer of data loaded in Fractalyse}
\end{figure}

\subsection{\texttt{Load network graph} menu}
If your network data is defined as a point layer and a table of links, you can load your network from the menu \texttt{Load network graph}.
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/load_network_dlg.png}
	\caption{Dialog box that opens with the \texttt{Load network graph} menu}
\end{figure}

\subsection{\texttt{Load estimation} menu}
A previously saved estimation can be reloaded from this menu entry. For more details, see \ref{save_estim}.

\subsection{Other menus}
Other \verb|File| menu entries are explained in \nameref{miscellaneous} chapter.

\section{Data handling: \texttt{Tools} menu}
In case of vector analyses, some types of data are not supported (for example, lines or polygons can not be used for a correlation analysis). When raster data are used, most analyses require binary input data. Fractalyse integrates functions in the \texttt{Tools} menu that enable the conversion of vector data into raster data (\texttt{Rasterize} menu) and the conversion of gray scale raster data into binary data (\texttt{Binarize} menu).

\subsection{\texttt{Rasterize} menu}
\label{rasterize}
The \texttt{Rasterize} menu converts vector data into raster data. Any vector layer can be rasterized. If \verb|Field| is not filled in, the result is a binary raster layer and a gray scale raster otherwise. If the vector layer contains polygons, the rasterization mode may be changed with \verb|Poly mode| option. 
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/rasterize-en.png}
	\caption{Rasterization of a vector layer}
\end{figure}

\subsection{\texttt{Binarize} menu}
The \texttt{Binarize} menu converts gray scale raster to black and white raster.
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/binarize.png}
	\caption{Binarization of a gray scale layer}
\end{figure}

\subsection{\texttt{Negative} menu}
The \texttt{Negative} menu reverses binary raster data  (i.e. black and white images). The user has to right click on the layer and select the \verb|Negative| menu. Black pixels become white and white pixels become black.

\subsection{\texttt{Selection} menu}
Selection menu allows to select a sub-part of a layer to analyse it separately. After selecting the region of interest by a rectangle, click on \verb|Create| button to create a new layer containing only the selected region.

\subsection{Contextual layer menu}
By right-clicking on a layer, user can access a contextual menu allowing to :
\begin{itemize}
    \item Remove: remove the current layer from Fractalyse
    \item Style: change the drawing style of the layer
    \item Export: save the current layer to a new file
\end{itemize}

\chapter{Fractal analysis in practice}
Fractalyse offers three analysis menus, one for each type of input data: Vector, Raster, Network.

\section{Choice of a scale range for the analysis}
All fractal analysis methods require to define the range of scales that will be considered for the analysis.
This sequence is given in a panel contained in each analysis frame.
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/sampling_panel.png}
	\caption{Choice of a scale range}
\end{figure}

The scale range is comprised between \texttt{Min size} and \texttt{Max size}. By default, the sequence of scales is geometric, which means that each scale value is multiplied by the value \texttt{Coef} (starting from \texttt{Min size}). When the sequence chosen is arithmetic, the value \texttt{Coef} is added to each scale value.
For geometric sequence, \texttt{Coef} must be strictly greater than 1, for arithmetic sequence \texttt{Coef} must be strictly greater than 0.

\texttt{Min size} and \texttt{Max size} values are by default automatically estimated from the input data. For raster data, \texttt{Min size} is the pixel size. For vector data, \texttt{Min size} is the size of the smallest element (polygon or line segment).
The value of \texttt{Max size} is set by default as the half of the minimum extent of the data layer.

For raster data, the scales have to be rounded to the pixel unit. This may result in slight deviations from the defined sequence.

\pagebreak

\section{\texttt{Vector} menu}

Fractal analysis for vector data.

\subsection{\texttt{Box counting} menu}
\label{box_vector_analysis}
The method is described in \ref{box_method}.
The user first needs to set the vector layer under consideration and defines the scale range for the analysis. She/he also has to set the value of two specific parameters: \verb|Number of grid positions| and \verb|View boxes|. At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} frame (see \ref{estim_mono}) and a new layer displaying the scale range at the bottom of the map is added.

\begin{figure}[H]
	\includegraphics[scale=0.5]{img/box_vector_dlg.png}
	\caption{\texttt{Box counting} dialog box}
\end{figure}

\subsubsection{\texttt{Number of grid positions}}
At each iteration step, a chosen \verb|Number of grid positions| are tested and the number of elements $N_i$ is counted for each grid position. The appropriate grid position corresponds to the lowest value of $N_i$. Note that, by the way, the position of the grid may vary from one iteration step to the next.

\subsubsection{\texttt{View boxes}}
If you check the \verb|View boxes| option, all the boxes containing data are saved at each iteration step and can be displayed on the map; one layer for each scale. Note that this option is memory intensive since the boxes kept in memory can be numerous.
\begin{figure}[H]
	\begin{subfigure}{0.49\textwidth}
		\includegraphics[scale=0.30]{img/viewbox_256.png}
		\caption*{Box size: 256}
	\end{subfigure}
	\begin{subfigure}{0.49\textwidth}
		\includegraphics[scale=0.30]{img/viewbox_512.png}
		\caption*{Box size: 512}
	\end{subfigure}
	\begin{subfigure}{0.49\textwidth}
		\includegraphics[scale=0.30]{img/viewbox_1024.png}
		\caption*{Box size: 1024}
	\end{subfigure}
	\begin{subfigure}{0.49\textwidth}
		\includegraphics[scale=0.30]{img/viewbox_2048.png}
		\caption*{Box size: 2048}
	\end{subfigure}
	
	\caption{Box counting - View boxes}
\end{figure}


\subsection{\texttt{Dilation} menu}
The method is described in \ref{dil_method}.
The user first needs to set the vector layer under consideration and defines the scale range for the analysis. She/he also has to set the value of two specific parameters: \verb|Stop at one cluster| and \verb|View dilated patterns|. At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} frame (see \ref{estim_mono}) and a new layer displaying the scale range at the bottom of the map is added.

In the estimation window, the curve of the number of clusters at each dilation size can also be displayed in the \verb|Other curve| panel.

\begin{figure}[H]
	\includegraphics[scale=0.5]{img/dilation_dlg.png}
	\caption{Dilation dialog box}
\end{figure}

\subsubsection{\texttt{Stop at one cluster}}
If the user selects the \verb|Stop at one cluster| option, the dilation stops when the dilated pattern is made up of a single polygon. Look at the pattern {dilation size 2048} on figure \ref{view_dil_fig}.

\subsubsection{\texttt{View dilated patterns}}
If the user selects the \verb|View dilated patterns| option, the dilated geometries are saved at each iteration step and can be displayed on the map; one layer for each scale. Note that this option can require a large amount of memory since all dilated geometries are kept in memory.
\label{view_dil_fig}
\begin{figure}[H]
	\begin{subfigure}{0.49\textwidth}
		\includegraphics[scale=0.30]{img/view_dilation_256.png}
		\caption*{Dilation size: 256}
	\end{subfigure}
	\begin{subfigure}{0.49\textwidth}
		\includegraphics[scale=0.30]{img/view_dilation_512.png}
		\caption*{Dilation size: 512}
	\end{subfigure}
	\begin{subfigure}{0.49\textwidth}
		\includegraphics[scale=0.30]{img/view_dilation_1024.png}
		\caption*{Dilation size: 1024}
	\end{subfigure}
	\begin{subfigure}{0.49\textwidth}
		\includegraphics[scale=0.30]{img/view_dilation_2048.png}
		\caption*{Dilation size: 2048}
	\end{subfigure}
	
	\caption{Dilation - View dilated patterns}
	\label{view_dil_fig}
\end{figure}

\subsection{\texttt{Correlation} menu}
\label{cor_vector_analysis}
The method is described in \ref{cor_method}. Only point data can be analyzed with the vector correlation. The analysis of lines or polygons requires first to rasterize (see \ref{rasterize}) the data, and then to analyse them with the raster correlation (\ref{cor_raster}).\\
The user first needs to set the vector layer under consideration and defines the scale range for the analysis. At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} frame (see \ref{estim_mono}) and a new layer displaying the scale range at the bottom of the map is added.
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/correlation_dlg.png}
	\caption{Correlation dialog box}
\end{figure}


\subsection{\texttt{Radial} menu}
The method is described in \ref{radial_method}.
The user first needs to set the vector layer under consideration and defines the scale range for the analysis. She/he also has to set the value of one specific parameter: \verb|Centre| that corresponds to the starting point of the counting process. The coordinates can be entered directly or set by clicking on the map.\\
At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} frame (see \ref{estim_mono}) and a new layer displaying the scale range on the map is added.\\
The counting unit depends on geometry type of the vector layer: 
\begin{itemize}
    \item puntal: number of points
    \item lineal: length
    \item polygonal: area
\end{itemize}
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/radial_dlg.png}
	\caption{Radial dialog box}
\end{figure}

\subsection{\texttt{Batch} menu}
Vector methods can be executed in batch mode on each subarea of a vector layer.
The subareas can be defined by a regular grid or another polygon layer.

\begin{figure}[H]
	\includegraphics[scale=0.4]{img/batch_dlg.png}
	\caption{Batch dialog box}
\end{figure}

Each resulting polygon contains the fractal dimension in its attributes and also the confidence interval and the r2.

\subsection{\texttt{Multifractal} menu}
The principles of multifractal analysis are described in \ref{multifractal_method}.
Fractalyse implements 2 multifractal analysis: boxcounting and sandbox.

\subsubsection{\texttt{Box counting} menu}
The method is described in \ref{multi_box_method}. The settings are exactly the same as the monofractal boxcounting analysis (see \ref{box_vector_analysis}).\\
At the end of the computation, the estimated fractal dimension spectrum is displayed in the \texttt{Multi-fractal estimation} frame (see \ref{estim_multi}) and a new layer displaying the scale range at the bottom of the map is added.

\subsubsection{\texttt{Sandbox} menu}
The method is described in \ref{multi_sandbox_method}. The settings are exactly the same as the correlation analysis (see \ref{cor_vector_analysis}).\\
At the end of the computation, the estimated fractal dimension spectrum is displayed in the \texttt{Multi-fractal estimation} frame (see \ref{estim_multi}) and a new layer displaying the scale range at the bottom of the map is added.


\section{\texttt{Raster} menu}
Fractal analysis for raster data.
Most analysis only work with binary raster except radial and multi-fractal sandbox which support binary and grayscale raster layers.

\subsection{\texttt{Box counting} menu}
\label{box_raster}
The method is described in \ref{box_method}.
The user first needs to set the binary raster layer under consideration and defines the scale range for the analysis. At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} frame (see \ref{estim_mono}) and a new layer displaying the scale range at the bottom of the map is added.
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/box_raster_dlg.png}
	\caption{Box counting dialog box}
\end{figure}

\subsection{\texttt{Dilation} menu}
The method is described in \ref{dil_method}.
The user first needs to set the binary raster layer under consideration and defines the scale range for the analysis. At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} frame (see \ref{estim_mono}) and a new layer displaying the scale range at the bottom of the map is added.
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/dil_raster_dlg.png}
	\caption{Dilation dialog box}
\end{figure}

\subsection{\texttt{Correlation} menu}
\label{cor_raster}
The method is described in \ref{cor_method}. 
The user first needs to set the binary raster layer under consideration and defines the scale range for the analysis. At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} frame (see \ref{estim_mono}) and a new layer displaying the scale range at the bottom of the map is added.
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/cor_raster_dlg.png}
	\caption{Correlation dialog box}
\end{figure}

\subsection{\texttt{Radial} menu}
The method is described in \ref{radial_method}.
The user first needs to set the raster layer (binary or grayscale) under consideration and defines the scale range for the analysis. She/he also has to set the value of one specific parameter: \verb|Centre| that corresponds to the starting point of the counting process. The coordinates can be entered directly or set by clicking on the map.\\
At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} frame (see \ref{estim_mono}) and a new layer displaying the scale range on the map is added.
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/radial_raster_dlg.png}
	\caption{Radial dialog box}
\end{figure}

\subsection{\texttt{Radial all points} menu}
This analysis applies radial method centered on each black pixel of the raster and estimates for each, the fractal dimension. The result is a raster where each black pixel contains the local fractal dimension. Additional rasters contain the $r^2$ quality of estimation and the confidence interval if \verb|Compute confidence interval| is checked. The default estimation model is $ax^d$ and can be changed.
The sampling sequence is arithmetic from size 1 to \verb|Max size|.  The max size can be estimated automatically by checking \verb|Auto threshold|. In this case a minimal max size must be given. The max size is estimated by finding the main inflexion point in the estimated curve between \verb|min| and \verb|Max size| parameters. If there is no inflexion point \verb|Max size| is used. With this option, an additional raster is added containing the estimated max size.

\begin{figure}[H]
	\includegraphics[scale=0.5]{img/radial_all_dlg.png}
	\caption{Radial all points dialog box}
\end{figure}

\begin{figure}[H]
	\includegraphics[scale=0.5]{img/radial_all_result.png}
	\caption{Radial all points result}
\end{figure}

\subsection{\texttt{Multifractal} menu}
The principles of multifractal analysis are described in \ref{multifractal_method}.
Fractalyse implements 2 multifractal analysis: boxcounting and sandbox.

\subsubsection{\texttt{Box counting} menu}
The method is described in \ref{multi_box_method}. The settings are exactly the same as the monofractal boxcounting analysis (see \ref{box_raster}).\\
At the end of the computation, the estimated fractal dimension spectrum is displayed in the \texttt{Multi-fractal estimation} frame (see \ref{estim_multi}) and a new layer displaying the scale range at the bottom of the map is added.

\subsubsection{\texttt{Sandbox} menu}
The method is described in \ref{multi_sandbox_method}. The settings are exactly the same as the correlation analysis (see \ref{cor_raster}).\\
At the end of the computation, the estimated fractal dimension spectrum is displayed in the \texttt{Multi-fractal estimation} frame (see \ref{estim_multi}) and a new layer displaying the scale range at the bottom of the map is added.

\section{\texttt{Network} menu}
This menu contains fractal analysis for network data. For each method, before defining the sampling as previous methods, user have to define the distance type and counting mass data to be used.

\subsection{Choice of distance and mass counting}
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/net_dist_panel.png}
	\caption{Network panel}
\end{figure}

First the distance measure must be set. It can be of 3 types:
\begin{itemize}
    \item (topology): topological distance ie. number of edges
    \item (length): length in spatial units of the edges
    \item layer attribute: the edge distance corresponds to its attribute value
\end{itemize}

After, the counted mass must be set. This mass corresponds to:
\begin{itemize}
    \item Distance: the total length of the network in the selected distance unit.
    \item Node attribute: the sum of the selected node attribute.
    \item Edge attribute: the sum of the selected edge attribute.
\end{itemize}

After setting these 2 parameters, the sampling can be set manually or automatically by clicking on \verb|Estimate sampling|.

\subsection{\texttt{Correlation} menu}
\label{cor_net}
The method is described in \ref{cor_method}. 
The user first needs to set the network layer under consideration, defines the distance type and the counted mass, and defines the scale range for the analysis. At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} dialog (see \ref{estim_mono}).
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/cor_net_dlg.png}
	\caption{Network correlation dialog box}
\end{figure}

\subsection{\texttt{Radial} menu}
The method is described in \ref{radial_method}. 
The user first needs to set the network layer under consideration, defines the distance type and the counted mass, and defines the scale range for the analysis. She/he also has to set the value of one specific parameter: \verb|Starting point| that corresponds to the starting point of the counting process. The coordinates can be entered directly or set by clicking on the map. The starting point will be automatically snapped to the nearest node of the network.
At the end of the computation, the estimated fractal dimension is displayed in the \texttt{Estimation} dialog (see \ref{estim_mono}).
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/radial_net_dlg.png}
	\caption{Network radial dialog box}
\end{figure}

\subsection{\texttt{Service} menu}
Not documented yet

\subsection{\texttt{Backbone} menu}
Not documented yet

\subsection{\texttt{Multifractal} menu}
The principles of multifractal analysis are described in \ref{multifractal_method}.
Fractalyse implements one multifractal analysis for network: sandbox.

\subsubsection{\texttt{Sandbox} menu}
The method is described in \ref{multi_sandbox_method}. The settings are exactly the same as the correlation analysis (see \ref{cor_net}).\\
At the end of the computation, the estimated fractal dimension spectrum is displayed in the \texttt{Multi-fractal estimation} dialog (see \ref{estim_multi}).

\chapter{Estimation module}
After the counting process, the fractal dimension(s) can be estimated with this module.
There is 2 main types of estimation depending of the counting method: monofractal and multifractal.
\section{Monofractal}
\label{estim_mono}
The principles of the monofractal estimation is described in \ref{monofractal_method}.
The empirical curve coming from the monofractal method is estimated by an OLS (ordinary least square) regression. The estimated D coefficient corresponds to the fractal dimension.
There is 2 types of regression in Fractalyse: 
\begin{itemize}
    \item LOG: the curve is logged to use a linear model $\log{y}=D\log{x}+b$. This type is used by default with geometric sequence.
    \item DIRECT: the curve is estimated with a power law function of type $y=ax^D$. This type is used by default with arithmetic sequence. 
\end{itemize}

It is strongly recommended to not change the \verb|Type| and the \verb|Model|.

\begin{figure}[H]
	\includegraphics[scale=0.5]{img/estim.png}
	\caption{Estimation window}
\end{figure}

The graph part shows the empirical curve as little circles and the estimated curve (regression model) as red line.

\subsubsection{Numerical results}
\begin{itemize}
    \item Dimension: the estimated fractal dimension (D coefficient of the model)
    \item a,b,c: other coefficients depending of the chosen model
    \item R2: the determination coefficient of the regression $r^2$
    \item p-value: the significance of the regression, must be lower than 0.001
    \item Confidence (95\%): the confidence interval of the fractal dimension at 95\%. Only computed for linear regression.
    \item Bootstrap confidence: the confidence interval of the fractal dimension at 95\% estimated by bootstrap. Computed for all models.
\end{itemize}

\subsubsection{Bounds}
By default the regression is calculated on all points of the empirical curve. User can remove some points at the start (left) or end (right) of the curve. The regression is automatically updated and also the scale range on the map.

\begin{figure}[H]
	\includegraphics[scale=0.4]{img/estim_bounds.png}
	\caption{Estimation with user defined bounds}
\end{figure}

\subsubsection{Scaling behaviour}
The scaling behaviour corresponds to the first derivative of the logged empirical curve. It shows the local estimates of the fractal dimension.

\begin{figure}[H]
	\includegraphics[scale=0.4]{img/scaling_behaviour.png}
	\caption{Scaling behaviour}
\end{figure}

\subsubsection{Other curve}
For some methods, there is additional curve. For the moment only dilation method produce additional curve: the number of clusters for each dilation size.

The \verb|Export| button allows to export all numerical results in a text file or export the graphical curves in SVG format.

The \verb|Save| button allows to save the estimation in XML format to reload it after. See \nameref{save_estim}.

\section{Multifractal}
\label{estim_multi}
The principles of the multifractal estimation is described in \ref{multifractal_method}.
The logged empirical curves ($M_q$) coming from the multifractal method are estimated by a linear OLS (ordinary least square) regression. The estimated slopes correspond to the $\tau_q$ curve.
\begin{figure}[H]
	\includegraphics[scale=0.5]{img/multi_estim_mq.png}
	\caption{Multifractal estimation window - $M_q$}
\end{figure}

\subsubsection{q set}
The set of $q$ can be changed with min, max and increment step. User have to click on \verb|Update| button after, to update all curves ($M_q$, $\tau_q$, ...) and numerical results.

\subsubsection{Numerical results}
The numerical results consist of the min/max fractal dimension spectrum $D_q$ and $D_0$ corresponding to the classical monofractal dimension.

\subsubsection{Bounds}
As monofractal estimation, the regression on $M_q$ curves can be only computed on a subset of scale sizes.

\subsubsection{Curves}
By default, the graph shows the $M_q$ curves. User can displayed the other curves : $\tau_q$, $D_q$ and $f(\alpha_q)$ by selecting it in the dropdown list.

\subsubsection{View estim}
Since there is many linear regressions (one for each $M_q$), they are not showed directly in the frame. Estimation of one $M_q$ curve can be shown by selecting the wanted $q$ and click on \verb|View estim| button. A monofractal estimation window is shown with the estimation of the selected $M_q$ curve.

The \verb|Export| button allows to export all numerical results in a text file or export the current graphical curves in SVG format.

The \verb|Save| button allows to save the estimation in XML format to reload it after. See \nameref{save_estim}. Be careful, the q-set cannot be changed after reloading it.

\subsubsection{Multifractal curves}
The $\tau_q$ curve must be monotonic decreasing.
\begin{figure}[H]
	\includegraphics[scale=0.4]{img/multi_estim_tq.png}
	\caption{Multifractal estimation window - $\tau_q$}
\end{figure}
The dimension spectrum $D_q$ must be monotonic decreasing. If not, the results cannot be used.
\begin{figure}[H]
	\includegraphics[scale=0.4]{img/multi_estim_dq.png}
	\caption{Multifractal estimation window - $D_q$}
\end{figure}

\begin{figure}[H]
	\includegraphics[scale=0.4]{img/multi_estim_falpha.png}
	\caption{Multifractal estimation window - $f(\alpha_q)$}
\end{figure}

\section{Save/reload estimation}
\label{save_estim}
Estimations can be saved and reloaded later. To save an estimation, use the \verb|Save| button on the estimation frame. The estimation is stored in XML format. If you have already closed the estimation frame you can reopen it from the layer panel of the main frame.
To reload an estimation, use the menu \verb|File - Load estimation|. After selecting the XML file, the estimation window will appear with the saved estimation.

For multifractal estimation, the q-range cannot be changed after reloading it.

\section{Estimation layer: scale range}
For each estimation frame, a new layer showing the scale range on the map is created.
This scale range is updated when user changes the bounds of the estimation.

The contextual menu of this layer allows to:
\begin{itemize}
    \item Remove: remove this estimation and the scale range layer
    \item Estimation: reload the estimation frame if you have already closed it
    \item Save: save the estimation in a XML file
\end{itemize}

\chapter{Miscellaneous}
\label{miscellaneous}
\section{\texttt{Preferences} menu}
\label{pref_menu}
\subsection{Memory}
The memory used by Fractalyse plays an important role. If there is not enough RAM, computation will be slower or may fail (OutOfMemoryError or GC Overhead message). This panel can be used to adjust the memory allocated to Fractalyse. If you have a 32-bit version of Java, Fractalyse will be limited to about 2 Go (2000 Mo) of memory. If your computer has more than 2 Go of RAM memory, it is highly recommended you install the 64-bit version of Java to use the available memory beyond 2 Go. After changing the amount of memory, you have to restart Fractalyse.

\subsection{Processors}
Most of Fractalyse calculations are parallelized. This means that Fractalyse can use several cores/processors to speed up computations, a quad-core processor being theoretically four times faster than a single-core processor. By default Fractalyse sets the number of cores to the number of computer cores minus 1.
After changing the parameter, you have to restart Fractalyse.

\section{\texttt{Log window} menu}
This window show some details when error occurred. These messages are useful for debugging purpose.


\part{Command line interface}

\chapter{Prerequisite}

Fractalyse can be used in command line interface (CLI).
It is useful for executing Fractalyse on a distant computer without a graphical interface, or batching some processes that are not available in the graphical user interface (GUI).

\section{Launch Fractalyse in CLI mode}
First you have to open a terminal window.
Then, go to the directory of the Fractalyse program with \textit{cd} command.
Finally, type the following command to display the Fractalyse help screen:
\begin{Verbatim}
java -jar fractalyse-3.0.jar --help
\end{Verbatim}
Result
\begin{Verbatim}
Usage :
java -jar fractalyse.jar [-proc n]
...
...
\end{Verbatim}
You're ready to use Fractalyse in CLI mode !

\section{Syntax}
\subsection{Definition}
Commands always start with a double dash (\verb|--|).\\
A global option starts with only one dash (\verb|-|).\\
A parameter does not have a dash.\\
\subsection{Character separator}
Blank spaces are used to separate commands and parameters. You cannot have a name containing blank spaces.\\

\subsection{Optional parameter}
Parameters enclosed in brackets are optional. 
Therefore, parameters not in brackets are mandatory.


\subsection{Command execution}
Fractalyse can execute only one command.

\begin{Verbatim}
java -jar fractalyse-3.0.jar ...
\end{Verbatim}




\chapter{Command reference}
\section{General command}
\subsection{\texttt{--help}: display help}
Command :
\begin{Verbatim}
	java -jar fractalyse-3.0.jar --help
\end{Verbatim}

Result :
\begin{Verbatim}
Usage :
java -jar fractalyse.jar [-mpi | -proc n] COMMAND
COMMAND:
	--rasterize [neg] res=val file_1.shp [... file_n.shp]
	--binarize min=val max=val file_1.tif [... file_n.tif]
	--boxcounting [gliding=val] SAMPLING [estim=log|direct] file_1.shp [... file_n.shp]
	--rboxcounting SAMPLING [estim=log|direct] file_1.tif [... file_n.tif]
	--dilation SAMPLING [estim=log|direct] file_1.shp [... file_n.shp]
	--rdilation SAMPLING [estim=log|direct] file_1.tif [... file_n.tif]
	--correlation SAMPLING [estim=log|direct] file_1.shp [... file_n.shp]
	--rcorrelation [border=val] SAMPLING [estim=log|direct] file_1.tif [... file_n.tif]
	--clusters [buf=radius]file_1.shp [... file_n.shp]
SAMPLING: 
	[coef=val] [min=val] [max=val] [seq=arith|geom]
\end{Verbatim}

\section{Data manipulation commands}
\subsection{\texttt{--rasterize}: convert vector to raster}
\begin{Verbatim}[commandchars=\\\{\}]
--rasterize [neg] res=\textit{val} \textit{file_1.shp} [... \textit{file_n.shp}]
\end{Verbatim}
This command converts vector files into raster tif file. Shapefile and Geopackage vector layer can be rasterized. The result is a binary raster layer. The new files have the same name. Only the file extension is changed.

\subsubsection{Parameters}
\begin{itemize}
    \item \verb|res=val|: the pixel resolution of the resulting raster
    \item \verb|neg|: if set pixel values are reverse,  black pixels become white and white pixels become black.
\end{itemize}

\subsection{\texttt{--binarize}: convert grayscale raster to binary}
\begin{Verbatim}[commandchars=\\\{\}]
--binarize min=\textit{val} max=\textit{val} \textit{file_1.tif} [... \textit{file_n.tif}]
\end{Verbatim}
This command converts gray scale raster to black and white raster. The new files name are suffixed with \verb|-bin|.
\subsubsection{Parameters}
\begin{itemize}
    \item \verb|min=val|: the minimal value for a pixel to become black
    \item \verb|max=val|: the maximal value for a pixel to become black.
\end{itemize}

\section{Monofractal analysis commands}
Each fractal method can be applied to one or more spatial data files. For each file, the counting process and the fractal dimension estimation are calculated and saved in a text file with the same name. Another text file named with the method and its parameters is also created containing the summary of all estimations.

The parameters are globally the same for all methods :
\begin{itemize}
    \item method: the methods name prefix with r for raster data
    \item optional parameters if any
    \item sampling: the scale sampling (optional)
    \item estimation type: logarithmic or direct (optional)
    \item one or more files corresponding to vector or raster layers
\end{itemize}

\subsection{\texttt{--boxcounting}: box counting on vector data}
\begin{Verbatim}[commandchars=\\\{\}]
--boxcounting [gliding=\textit{val}] SAMPLING [estim=log|direct] \textit{file_1.shp} [... \textit{file_n.shp}]
\end{Verbatim}
This command apply the vector boxcounting method to one or more vector layers.
The method is described in \ref{box_method}. The sampling configuration is described in \ref{cli_sampling} and the estimation type in \ref{cli_estim}.
\subsubsection{Optional parameter}
\begin{itemize}
    \item \verb|gliding=val|: number of gliding grid tested. For more details see \verb|Number of grid positions| in section \ref{box_method}.
\end{itemize}

For each vector file a text file with the same name is created containing the detail of each estimation.
One text file is also created containing the summary of all fractal estimations.

\subsection{\texttt{--rboxcounting}: box counting on raster data}
\begin{Verbatim}[commandchars=\\\{\}]
--rboxcounting SAMPLING [estim=log|direct] \textit{file_1.tif} [... \textit{file_n.tif}]
\end{Verbatim}
This command apply the raster boxcounting method to one or more raster layers.
The method is described in \ref{box_method}. The sampling configuration is described in \ref{cli_sampling} and the estimation type in \ref{cli_estim}.

For each raster file a text file with the same name is created containing the detail of each estimation.
One text file is also created containing the summary of all fractal estimations.

\subsection{\texttt{--dilation}: dilation on vector data}
\begin{Verbatim}[commandchars=\\\{\}]
--dilation SAMPLING [estim=log|direct] \textit{file_1.shp} [... \textit{file_n.shp}]
\end{Verbatim}
This command apply the vector dilation method to one or more vector layers.
The method is described in \ref{dil_method}. The sampling configuration is described in \ref{cli_sampling} and the estimation type in \ref{cli_estim}.

For each vector file a text file with the same name is created containing the detail of each estimation.
One text file is also created containing the summary of all fractal estimations.

\subsection{\texttt{--rdilation}: dilation on raster data}
\begin{Verbatim}[commandchars=\\\{\}]
--rdilation SAMPLING [estim=log|direct] \textit{file_1.tif} [... \textit{file_n.tif}]
\end{Verbatim}
This command apply the raster dilation method to one or more raster layers.
The method is described in \ref{dil_method}. The sampling configuration is described in \ref{cli_sampling} and the estimation type in \ref{cli_estim}.

For each raster file a text file with the same name is created containing the detail of each estimation.
One text file is also created containing the summary of all fractal estimations.

\subsection{\texttt{--correlation}: correlation on vector data}
\begin{Verbatim}[commandchars=\\\{\}]
--correlation SAMPLING [estim=log|direct] \textit{file_1.shp} [... \textit{file_n.shp}]
\end{Verbatim}
This command apply the vector correlation method to one or more point vector layers.
The method is described in \ref{cor_method}. The sampling configuration is described in \ref{cli_sampling} and the estimation type in \ref{cli_estim}.

For each vector file a text file with the same name is created containing the detail of each estimation.
One text file is also created containing the summary of all fractal estimations.

\subsection{\texttt{--rcorrelation}: correlation on raster data}
\begin{Verbatim}[commandchars=\\\{\}]
--rcorrelation [border=val] SAMPLING [estim=log|direct] \textit{file_1.tif} [... \textit{file_n.tif}]
\end{Verbatim}
This command apply the raster correlation method to one or more raster layers.
The method is described in \ref{cor_method}. The sampling configuration is described in \ref{cli_sampling} and the estimation type in \ref{cli_estim}.
\subsubsection{Optional parameter}
\begin{itemize}
    \item \verb|border=val|: exclude pixels as counting centre too near from the raster border to avoid border effect. The value given corresponds to the distance from the raster border in pixel. To avoid completely border effect, user have to give the same distance in maxsize sampling parameter with respect to spatial unit.
\end{itemize}
For each raster file a text file with the same name is created containing the detail of each estimation.
One text file is also created containing the summary of all fractal estimations.

\subsection{\texttt{SAMPLING}: scale range definition}
\label{cli_sampling}
\begin{Verbatim}[commandchars=\\\{\}]
[coef=\textit{val}] [min=\textit{val}] [max=\textit{val}] [seq=arith|geom]
\end{Verbatim}
All fractal analysis methods require to define the range of scales that will be considered for the analysis. If not set the sampling is automatically estimated from the data layer.

\subsubsection{Optional parameters}
\begin{itemize}
    \item \verb+seq=arith|geom+: arithmetic or geometric sequence. By default the sequence sampling is set to geometric.
    \item \verb|coef=val|: coefficient for increasing scales from \verb|min| to \verb|max|. By default $coef=2$ for geometric sequence and $coef=1$ for arithmetic sequence.
    \item \verb|min=val|: the minimal scale size
    \item \verb|max=val|: the maximal scale size
\end{itemize}
The scale range is comprised between \verb|min| and \verb|max|. By default, the sequence of scales is geometric, which means that each scale value is multiplied by the value \verb|coef| (starting from \verb|min|). When the sequence chosen is arithmetic, the value \verb|coef| is added to each scale value.
For geometric sequence, \verb|coef| must be strictly greater than 1, for arithmetic sequence \verb|coef| must be strictly greater than 0.

The parameters \verb|min| and \verb|max| are by default automatically estimated from the input data. For raster data, \verb|min| is the pixel size. For vector data, \verb|min| is the size of the smallest element (polygon or line segment).
The \verb|max| parameter is set by default as the half of the minimum extent of the data layer. If a fractal method is applied on several data layer the sampling range (min and max size) may differ for each layer.

For raster data, the scales have to be rounded to the pixel unit. This may result in slight deviations from the defined sequence.

\subsection{Estimation parameter}
\label{cli_estim}
\begin{Verbatim}[commandchars=\\\{\}]
[estim=log|direct]
\end{Verbatim}
By default, the estimation type (log or direct) is set depending on the sequence sampling: for geometric sequence the estimation is logarithmic and for arithmetic sequence the direct type is used. User can change this behaviour by adding \verb|estim| parameter. For more details on estimation method, see \ref{estim_mono}.

\section{Other commands}
\subsection{\texttt{--clusters}: counting clusters for vector layer}
\begin{Verbatim}[commandchars=\\\{\}]
--clusters [buf=radius] \textit{file_1.shp} [... \textit{file_n.shp}]
\end{Verbatim}



\section{Options}

\subsection{\texttt{-proc}}
Defines the number of processors (or cores) used by Fractalyse.
By default, CLI mode uses the value defined in the preferences window.
See the \nameref{perf_cli} section for more details.

\subsection{\texttt{-mpi}}
This option is used to execute commands on several computers in the MPI environment. See the parallelism section of \nameref{perf_cli} for more details.

\chapter{Examples of commands}

\section{Data handling commands}

\subsubsection{--rasterize}
The following command rasterizes all vector geopackage files contained in the current directory. For each .gpkg file, it creates a new raster .tif file with a resolution  of 5 meters. Each new file has the same name with the suffix: \verb|_res5.tif|.
\begin{Verbatim}
	java -jar fractalyse-3.0.jar --rasterize res=5 *.gpkg
\end{Verbatim}

\subsubsection{--binarize}
The following command binarizes all tif images contained in the current directory. For each .tif file, it creates a new file in which each pixel having a value between 1 and 10 is set to 1 and to 0 otherwise. Each new file has a name with the suffix: \verb|_bin1-10.tif|.
\begin{Verbatim}
	java -jar fractalyse-3.0.jar --binarize min=1 max=10 *.tif
\end{Verbatim}

\section{Fractal analysis commands}
The following command calculates the fractal dimension with box counting method for each raster previously binarized.
\begin{Verbatim}
	java -jar fractalyse-3.0.jar --rboxcounting *_bin*.tif
\end{Verbatim}

The following command calculates the fractal dimension with box counting method for each raster previously binarized and the scale sampling range is set between 10 and 1000. The sequence is left unchanged (geometric) and also the coefficient (coef = 2).
\begin{Verbatim}
	java -jar fractalyse-3.0.jar --rboxcounting min=10 max=1000 *_bin*.tif
\end{Verbatim}

The same principle can be applied for all monofractal methods.

\chapter{Performance tuning}
\label{perf_cli}
\section{Parallelism to speed up execution}
\subsection{One computer: threads}
If your computer has more than one core (most of them), you can take advantage of parallelism. 
Most Fractalyse commands are parallelized. You can speed up command execution by defining the number of cores (or processors) used by Fractalyse with the option \verb|-proc| after the project command:
\begin{Verbatim}
	java -jar fractalyse-3.0.jar -proc 8 ...
\end{Verbatim}
By default, CLI mode uses the number of processors defined in the \verb|Preferences| window of the GUI.
\subsection{Computer cluster: mpi}
Fractalyse can be run on computer clusters wich support Java for OpenMPI.
\begin{Verbatim}
	mpirun java -jar fractalyse-3.0.jar -mpi  ...
\end{Verbatim}
Only some commands can be used in mpi environments: --boxcounting and --rcorrelation
\section{Memory management}
In CLI mode, the memory configuration defined in the \verb|Preferences| window cannot be used.
By default, the amount of memory available for Fractalyse is system dependent. It can vary from 128 Mb to several Gb.
In most cases, Fractalyse runs normally. But if a large image is analysed, some commands would be slow or even crash due to memory limitation.
If Fractalyse execution ends up with the message \verb|OutOfMemoryError|, \verb|GC overhead| or \verb|Java Heap space|, you need to increase the memory allocated to Fractalyse.

To define manually the maximum amount of memory allocated to Fractalyse, use Java option \verb|-Xmx| :
\begin{Verbatim}
	java -Xmx2g -jar fractalyse-3.0.jar ... # 2Gb allocated
	java -Xmx1500m -jar fractalyse-3.0.jar ... # 1500 Mb -> 1.5Gb allocated
\end{Verbatim}
If you cannot allocate more than 1Gb or 1.5G although your computer has more memory available, you have probably a 32-bit version of Java, which is limited to less than 2Gb of memory.
Check your Java version:
\begin{Verbatim}
	java -version
\end{Verbatim}
If it is a 32-bit version, install a 64-bit Java version to handle all your computer memory.

\end{document}          
